; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 400
WINDOWHEIGHT = 440
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 + (sizeof WNDCLASSEX)
;	push	sizeof WNDCLASSEX       ;cbSize & style
	push	rax
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local ps:PAINTSTRUCT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
; --------------- Free the memory allocated for the spheres
	mov	ecx,GlSphere1
	invoke	gluDeleteQuadric
	mov	ecx,GlSphere2
	invoke	gluDeleteQuadric
	mov	ecx,GlSphere3
	invoke	gluDeleteQuadric
	mov	ecx,GlSphere4
	invoke	gluDeleteQuadric
	mov	ecx,GlSphere5
	invoke	gluDeleteQuadric
	mov	ecx,GlSphere6
	invoke	gluDeleteQuadric
	mov	ecx,GlSphere7
	invoke	gluDeleteQuadric
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset pfd
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset pfd
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;Init the scene --------------- 
	mov	r8d,offset LightAmbient
	mov	edx,offset LightSourcePosition
	invoke	SetLightSource,GL_LIGHT0
	mov	r8d,offset Light2Ambient
	mov	edx,offset LightSource2Position
	invoke	SetLightSource,GL_LIGHT1
	mov	r8d,offset Light3Ambient
	mov	edx,offset LightSource3Position
	invoke	SetLightSource,GL_LIGHT2

	mov	qword ptr [rsp+28h],24
	movr	qword ptr [rsp+20h],Sphere1Radius
	mov	r9d,offset Sphere1Color
	invoke	CreateSphere,1,GLU_FILL,GLU_SMOOTH
	mov	GlSphere1,eax
	mov	qword ptr [rsp+28h],16
	movr	qword ptr [rsp+20h],Sphere2Radius
	mov	r9d,offset Sphere2Color
	invoke	CreateSphere,2,GLU_FILL,GLU_SMOOTH
	mov	GlSphere2,eax
	mov	qword ptr [rsp+28h],16
	movr	qword ptr [rsp+20h],Sphere3Radius
	mov	r9d,offset Sphere3Color
	invoke	CreateSphere,3,GLU_FILL,GLU_SMOOTH
	mov	GlSphere3,eax
	mov	qword ptr [rsp+28h],16
	movr	qword ptr [rsp+20h],Sphere4Radius
	mov	r9d,offset Sphere4Color
	invoke	CreateSphere,4,GLU_FILL,GLU_SMOOTH
	mov	GlSphere4,eax
	mov	qword ptr [rsp+28h],16
	movr	qword ptr [rsp+20h],Sphere5Radius
	mov	r9d,offset Sphere5Color
	invoke	CreateSphere,5,GLU_FILL,GLU_SMOOTH
	mov	GlSphere5,eax
	mov	qword ptr [rsp+28h],16
	movr	qword ptr [rsp+20h],Sphere6Radius
	mov	r9d,offset Sphere6Color
	invoke	CreateSphere,6,GLU_FILL,GLU_SMOOTH
	mov	GlSphere6,eax
	mov	qword ptr [rsp+28h],16
	movr	qword ptr [rsp+20h],Sphere7Radius
	mov	r9d,offset Sphere7Color
	invoke	CreateSphere,7,GLU_FILL,GLU_SMOOTH
	mov	GlSphere7,eax
; Set global flags
	invoke	glEnable,GL_DEPTH_TEST
	invoke	glEnable,GL_LIGHTING
	invoke	glEnable,GL_CULL_FACE		; Don't render back faces
	invoke	glShadeModel,GL_SMOOTH
	invoke	glEnable,GL_NORMALIZE

	invoke	SetTimer,hWin,10,25,0;  #10  50mSec
	invoke	ResizeObject,WINDOWWIDTH, WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	mov	edx,r9d
	movzx	ecx,dx
	shr	edx,16
	invoke	ResizeObject
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke	glPushMatrix
	mov	r9d,offset Sphere1AnglesFlt
	mov	r8d,offset Sphere1AnglesSpeedFlt
	mov	edx,offset Sphere1Position
	invoke	RotateObject,1
	invoke	glPushMatrix
	mov	r9d,offset Sphere2AnglesFlt
	mov	r8d,offset Sphere2AnglesSpeedFlt
	mov	edx,offset Sphere2Position
	invoke	RotateObject,2
	mov	r8d,offset LightSourcePosition
	invoke	glLightfv,GL_LIGHT0,GL_POSITION
	invoke	glPopMatrix
	invoke	glPushMatrix
	mov	r9d,offset Sphere3AnglesFlt
	mov	r8d,offset Sphere3AnglesSpeedFlt
	mov	edx,offset Sphere3Position
	invoke	RotateObject,3
	mov	r8d,offset LightSource2Position
	invoke	glLightfv,GL_LIGHT1,GL_POSITION
	invoke	glPopMatrix
	invoke	glPushMatrix
	mov	r9d,offset Sphere4AnglesFlt
	mov	r8d,offset Sphere4AnglesSpeedFlt
	mov	edx,offset Sphere4Position
	invoke	RotateObject,4
	mov	r8d,offset LightSource3Position
	invoke	glLightfv,GL_LIGHT2,GL_POSITION
	invoke	glPopMatrix
	invoke	glPushMatrix
	mov	r9d,offset Sphere5AnglesFlt
	mov	r8d,offset Sphere5AnglesSpeedFlt
	mov	edx,offset Sphere5Position
	invoke	RotateObject,5
	invoke	glPopMatrix
	invoke	glPushMatrix
	mov	r9d,offset Sphere6AnglesFlt
	mov	r8d,offset Sphere6AnglesSpeedFlt
	mov	edx,offset Sphere6Position
	invoke	RotateObject,6
	invoke	glPopMatrix
	invoke	glPushMatrix
	mov	r9d,offset Sphere7AnglesFlt
	mov	r8d,offset Sphere7AnglesSpeedFlt
	mov	edx,offset Sphere7Position
	invoke	RotateObject,7
	invoke	glPopMatrix
	invoke	glPopMatrix
	invoke	SwapBuffers,hDC
wmBYE:	leave
	retn	
WndProc	endp
; --------------- Position and rotate an object
RotateObject	PROC	ListNumber:QWORD,XYZPosition:QWORD,XYZRotations:QWORD,XYZAngles:QWORD
LOCAL	LocXSpd:DWORD
LOCAL	LocYSpd:DWORD
LOCAL	LocZSpd:DWORD
LOCAL	LocXAngle:DWORD
LOCAL	LocYAngle:DWORD
LOCAL	LocZAngle:DWORD

	mov	ListNumber,rcx
	mov	XYZRotations,r8
	mov	XYZAngles,r9

	movd	xmm0,dword ptr [rdx]
	movd	xmm1,dword ptr [rdx+4]
	movd	xmm2,dword ptr [rdx+8]
	invoke	glTranslatef
	mov	rax,XYZAngles; Rotate X
	mov	rdx,XYZRotations
	fld	DWORD PTR [rax]
	fadd	DWORD PTR [rdx]
	fstp	DWORD PTR [rax]
	movd	xmm3,ebx
	movd	xmm2,const1
	movd	xmm1,ebx
	movd	xmm0,dword ptr [rax]
	invoke	glRotatef
	mov	rax,XYZAngles; Rotate Y
	mov	rdx,XYZRotations
	fld	DWORD PTR [rax+4]
	fadd	DWORD PTR [rdx+4]
	fstp	DWORD PTR [rax+4]
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1
	movd	xmm0,dword ptr [rax+4]
	invoke	glRotatef
	mov	rax,XYZAngles; Rotate Z
	mov	rdx,XYZRotations
	fld	DWORD PTR [rax+8]
	fadd	DWORD PTR [rdx+8]
	fstp	DWORD PTR [rax+8]
	movd	xmm3,const1
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,dword ptr [rax+8]
	invoke	glRotatef
	invoke	glCallList,ListNumber
	leave
	retn
RotateObject	ENDP
; --------------- Resize the scene
ResizeObject proc
	enter 40h,0

	mov	r8d,ecx
	mov	r9d,edx
	invoke	glViewport,0,0
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glLoadIdentity
	movq	xmm3,constd7
	movq	xmm2,constd3
	movq	xmm1,constd1
	movq	xmm0,constd45
	invoke	gluPerspective
	invoke	glMatrixMode,GL_MODELVIEW
	invoke	glLoadIdentity
	leave
	retn
ResizeObject proc
; --------------- Create a sphere with glu object
CreateSphere	proc	ListNumber:QWORD,FillType:QWORD,NormalsType:QWORD,\
			Color:QWORD,Radius:QWORD,Parts:QWORD
LOCAL	GlSphere:QWORD

	mov	Color,r9

	invoke	glNewList,,GL_COMPILE
; Create a template
	invoke	gluNewQuadric
	mov	GlSphere,rax
; Set object draw style
	invoke	gluQuadricDrawStyle,eax,GLU_FILL
; Set normals style
	invoke	gluQuadricNormals,GlSphere,GLU_SMOOTH
; Set object color
	invoke	glMaterialfv,GL_FRONT,GL_AMBIENT_AND_DIFFUSE,Color
	mov	rax,Radius
; Create a sphere primitive
	movq	xmm1,qword ptr [rax]
	invoke	gluSphere,GlSphere,,Parts,Parts
	invoke	glEndList
	mov	rax,GlSphere
	leave
	retn
CreateSphere	endp

; --------------- Set a light source
SetLightSource	PROC	LtNumber:QWORD,LtPosition:QWORD,LtAmbient:QWORD
        mov	LtNumber,rcx
	mov	LtPosition,rdx
	mov	LtAmbient,r8

	invoke	glLightfv,,GL_POSITION,LtPosition
	mov	r8d,offset LightDiffuse
	invoke	glLightfv,LtNumber,GL_DIFFUSE
	mov	r8d,offset LightSpecular
	invoke	glLightfv,LtNumber,GL_SPECULAR
	invoke	glLightfv,LtNumber,GL_AMBIENT,LtAmbient
	mov	r8d,offset LightConstAtt
	invoke	glLightfv,LtNumber,GL_CONSTANT_ATTENUATION
	mov	r8d,offset LightLinAtt
	invoke	glLightfv,LtNumber,GL_LINEAR_ATTENUATION
	mov	r8d,offset LightQuadAtt
	invoke	glLightfv,LtNumber,GL_QUADRATIC_ATTENUATION
	mov	r8d,offset SpotCut
	invoke	glLightfv,LtNumber,GL_SPOT_CUTOFF
	mov	r8d,offset SpotExp
	invoke	glLightfv,LtNumber,GL_SPOT_EXPONENT
	mov	r8d,offset SpotDir
	invoke	glLightfv,LtNumber,GL_SPOT_DIRECTION
	invoke	glEnable,LtNumber
	leave
	retn
SetLightSource	ENDP
;.data--------------------------------------------
hDC	dq	?
hrc	dq	?
pfd	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DRAW_TO_WINDOW or PFD_DOUBLEBUFFER;  OpenGL   
  	iPixelType        db	PFD_TYPE_RGBA;  RedGreenBlueAlpha
  	cColorBits        db	8;Select Our Color Depth  
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer  
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

const1		dd 1.0
constd1		dq 1.0
constd3		dq 3.0
constd7		dq 7.0
constd45	dq 45.0

; Light position
LightSourcePosition	dd	-2.0,-2.0,-4.0,0.0
LightSource2Position	dd	2.0,2.0,4.0,0.0
LightSource3Position	dd	-2.0,2.0,4.0,0.0
LightAmbient		dd	0.2,0.0,0.0,1.0
Light2Ambient		dd	0.0,0.2,0.0,1.0
Light3Ambient		dd	0.0,0.0,0.2,1.0
LightDiffuse		dd	1.0,1.0,1.0,1.0
LightSpecular		dd	1.0,1.0,1.0,1.0
SpotCut			dd	-1.0
SpotExp			dd	0.0
SpotDir			dd	-1.0,-1.0,-1.0
LightConstAtt		dd	1.0
LightLinAtt		dd	1.0
LightQuadAtt		dd	1.0

; --- Sphere 1
; Angles
Sphere1AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere1AnglesSpeedFlt	dd	-1.0,-1.2,-1.4
; Objects datas
Sphere1Color		dd	0.6,0.4,0.2,0.0
Sphere1Radius		dq	1.0
Sphere1Position		dd	0.0,0.0,-5.0
GlSphere1		dd	0

; --- Sphere 2
; Angles
Sphere2AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere2AnglesSpeedFlt	dd	-1.0,0.8,-0.4
; Objects datas
Sphere2Color		dd	0.4,0.6,0.2,0.0
Sphere2Radius		dq	0.3
Sphere2Position		dd	0.0,0.0,-1.5
GlSphere2		dd	0

; --- Sphere 3
; Angles
Sphere3AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere3AnglesSpeedFlt	dd	-1.0,-0.8,1.4
; Objects datas
Sphere3Color		dd	0.2,0.4,0.6,0.0
Sphere3Radius		dq	0.3
Sphere3Position		dd	0.0,0.0,1.5
GlSphere3		dd	0

; --- Sphere 4
; Angles
Sphere4AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere4AnglesSpeedFlt	dd	-1.0,1.4,-0.8
; Objects datas
Sphere4Color		dd	0.4,0.2,0.6,0.0
Sphere4Radius		dq	0.3
Sphere4Position		dd	0.0,1.5,0.0
GlSphere4		dd	0

; --- Sphere 5
; Angles
Sphere5AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere5AnglesSpeedFlt	dd	1.0,1.8,0.8
; Objects datas
Sphere5Color		dd	0.6,0.2,0.4,0.0
Sphere5Radius		dq	0.3
Sphere5Position		dd	1.5,0.0,0.0
GlSphere5		dd	0

; --- Sphere 6
; Angles
Sphere6AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere6AnglesSpeedFlt	dd	1.0,-1.8,2.0
; Objects datas
Sphere6Color		dd	0.2,0.6,0.4,0.0
Sphere6Radius		dq	0.3
Sphere6Position		dd	-1.5,0.0,0.0
GlSphere6		dd	0
; --- Sphere 7
; Angles
Sphere7AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere7AnglesSpeedFlt	dd	-2.1,-1.8,2.0
; Objects datas
Sphere7Color		dd	0.6,0.6,0.6,0.0
Sphere7Radius		dq	0.3
Sphere7Position		dd	0.0,-1.5,0.0
GlSphere7		dd	0

szClassName	db "Uncle Remus tales:#40 OpenGL - Planets",0
FileName	db "..\Images\br_Rabbit3.cur",0
end